<?php

/**
 * Copyright Souke (2018)
 *
 * contact@souke.fr
 *
 * Ce logiciel est un programme informatique servant à aider les producteurs
 * à distribuer leur production en circuits courts.
 *
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 *
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 *
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 */

namespace backend\controllers;

use domain\Product\Accessory\Accessory;
use yii\base\Response;
use yii\db\StaleObjectException;
use yii\filters\AccessControl;
use yii\web\NotFoundHttpException;

class AccessoryController extends BackendController
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['@'],
                        'matchCallback' => function ($rule, $action) {
                            return $this->getUserModule()
                                ->getAuthorizationChecker()
                                ->isGrantedAsProducer($this->getUserCurrent());
                        }
                    ]
                ],
            ],
        ];
    }

    public function actionIndex()
    {
        return $this->render('index', [
            'dataProvider' => $this->getAccessoryModule()->getRepository()
                ->queryAccessories()->getDataProvider(20),
        ]);
    }

    public function actionCreate()
    {
        $accessoryModule = $this->getAccessoryModule();
        $accessoryModel = $accessoryModule->getBuilder()->instanciateAccessory($this->getProducerCurrent());

        if ($accessoryModel->load(\Yii::$app->request->post()) && $accessoryModel->validate()) {
            $accessory = $accessoryModule->getManager()->createAccessory(
                $this->getProducerCurrent(),
                $accessoryModel->getName(),
                $accessoryModel->getQuantity()
            );
            $this->afterSave($accessory, $accessoryModel->getSelectedProductsIds());
            $this->setFlash('success', "Accessoire ajouté");
            return $this->redirectAfterSave('accessory', $accessory->getId());
        }

        return $this->render('create', [
            'accessory' => $this->initFormModel($accessoryModel),
            'productsArray' => $this->findProducts()
        ]);
    }

    /**
     * @throws NotFoundHttpException
     */
    public function actionUpdate(int $id)
    {
        $accessory = $this->findAccessory($id);

        if ($accessory->load(\Yii::$app->request->post()) && $accessory->validate() && $accessory->save()) {
            $this->afterSave($accessory, $accessory->getSelectedProductsIds());
            return $this->redirectAfterSave('accessory', $accessory->getId());
        }

        return $this->render('update', [
            'accessory' => $this->initFormModel($accessory),
            'productsArray' => $this->findProducts()
        ]);
    }

    /**
     * @throws \Throwable
     * @throws StaleObjectException
     * @throws NotFoundHttpException
     */
    public function actionDelete(int $id): Response
    {
        $accessory = $this->findAccessory($id);
        if($accessory->delete()) {
            $this->setFlash('success', "Accessoire supprimé");
        }

        return $this->redirect('index');
    }

    public function afterSave(Accessory $accessory, $selectedProductsIdsArray): void
    {
        if(!is_array($selectedProductsIdsArray)) {
            $selectedProductsIdsArray = [];
        }
        $this->getAccessoryModule()->getManager()->manageProducts($accessory, $selectedProductsIdsArray);
    }

    public function findProducts(): array
    {
        return $this->getProductModule()->getRepository()->findProducts(true);
    }

    /**
     * @throws NotFoundHttpException
     */
    protected function findAccessory($id): Accessory
    {
        if (($accessory = $this->getAccessoryModule()->getRepository()->findOneAccessoryById($id)) !== null) {
            return $accessory;
        } else {
            throw new NotFoundHttpException("L'accessoire n'a pas été trouvé.");
        }
    }

    public function initFormModel(Accessory $accessoryModel)
    {
        $this->getAccessoryModule()->getBuilder()->initSelectedProductsIds($accessoryModel);
        return $accessoryModel;
    }
}
